require ("util")
require ("libs/util_ext")
require ("libs/event")
require ("libs/list_ammo")

local loaded
local ammo_setting_table = {{LCT = "distractor-capsule", CRC = "cluster-cannon-shell", CRR = "explosive-multiple-rocket"},
							{LCT = nil, CRC = nil, CRR = nil},
							{LCT = false, CRC = false, CRR = false},
							{LCT = 5, CRC = 20, CRR = 20}}
------------------------------
script.on_load(function()

	if global.Artillery_Table ~= nil then
		Event.register(defines.events.on_tick, function(event) end)
	end
	
end)

script.on_init(function()
	
end)

script.on_configuration_changed(function()
	
	if global.Artillery_Table ~= nil then
		Event.register(defines.events.on_tick, function(event) end)
	end
	
end)
------------------------------

script.on_event({defines.events.on_built_entity,}, function(event) On_Built(event) end)
script.on_event({defines.events.on_robot_built_entity,}, function(event) On_Built(event) end)

script.on_event(defines.events.on_trigger_created_entity, function(event) AddMark(event) end)
script.on_event(defines.events.on_preplayer_mined_item, function(event) Recall_Items(event) end)

script.on_event(defines.events.on_player_created, function(event)
	local player = game.players[event.player_index]
end)

script.on_event(defines.events.on_gui_click, function(event)
	if event.element.name == "at_setting" then
		expand_button(game.players[event.player_index])
		ammo_setting_table[2].LCT = nil
		ammo_setting_table[2].CRC = nil
		ammo_setting_table[2].CRR = nil
		ammo_setting_table[3].LCT = false
		ammo_setting_table[3].CRC = false
		ammo_setting_table[3].CRR = false
		
	elseif event.element.name == "at_save_button" then
		save_button(game.players[event.player_index])
		-- writeDebug("Apply")
		
	elseif string.sub(event.element.name, 1, 6) == "at_LCT" then
		ammo_selected_button(event, ammo_list.capsules)
	elseif string.sub(event.element.name, 1, 6) == "at_CRC" then
		ammo_selected_button(event, ammo_list.shells)
	elseif string.sub(event.element.name, 1, 6) == "at_CRR" then
		ammo_selected_button(event, ammo_list.rockets)
		
	elseif event.element.name == "at_button_stop" then
		finish_button(game.players[event.player_index])
		
	elseif event.element.name == "at_button_view" then
		view_area(game.players[event.player_index])
	end
end)

script.on_event(defines.events.on_gui_checked_state_changed, function(event)
	if event.element.name == "at_radio_all" then
		-- writeDebug("radio - all")
		game.players[event.player_index].gui.left.at_button.at_radio_frame.at_radio_near.state = false
	elseif event.element.name == "at_radio_near" then
		-- writeDebug("radio - near")
		game.players[event.player_index].gui.left.at_button.at_radio_frame.at_radio_all.state = false
		
	elseif event.element.name == "at_checkbox_LCT" then
		-- writeDebug("checkbox - LCT")
		ammo_setting_table[3].LCT = event.element.state
	elseif event.element.name == "at_checkbox_CRC" then
		-- writeDebug("checkbox - CRC")
		ammo_setting_table[3].CRC = event.element.state
	elseif event.element.name == "at_checkbox_CRR" then
		-- writeDebug("checkbox - CRR")
		ammo_setting_table[3].CRR = event.element.state
	end
end)

script.on_event(defines.events.on_gui_text_changed, function(event)
	if event.element.name == "at_LCT_input_textfield" then
		number_holic(event)
	elseif event.element.name == "at_CRC_input_textfield" then
		number_holic(event)
	elseif event.element.name == "at_CRR_input_textfield" then
		number_holic(event)
	end
end)

script.on_event("at_button_opener", function(event)
	local player = game.players[event.player_index]
	create_button(player)
end)

Event.register(defines.events.on_tick, function(event)
	if global.Artillery_Table ~= nil then
		if global.Artillery_Counter == 0 or global.Artillery_Counter == nil then
			global.Artillery_Counter = 20 -- 60 = 1s, 10 = 1/6s
			
			for _, player in pairs(game.players) do
				if player.gui.left.at_on_off_table then
					change_request_chest(player)
				end
			end
			
			for ix, vx in pairs(global.Artillery_Table) do
				-- if vx[1].valid and vx[2].valid and vx[3].valid then
				if vx[1].valid and vx[2].valid then
					vx[4] = vx[4]-1
					if vx[4] <= 0 then
						Artillery_Check(vx)
						Artillery_health_check(vx)
					end
				else
					Artillery_destroy(vx)
					table.remove(global.Artillery_Table, ix)
					if #global.Artillery_Table == 0 then
						global.Artillery_Table = nil
					end
				end
			end
		else
			global.Artillery_Counter = global.Artillery_Counter - 1
		end
	end
end)

---------------------- buttons
function create_button(player)

	local setting = player.gui.left.at_setting
	local on_off_table = player.gui.left.at_on_off_table
	
	if setting then
		setting.destroy()
		if player.gui.left["at_button"] then
			player.gui.left["at_button"].destroy()
		end
	elseif on_off_table then
		ammo_setting_table[2].LCT = nil
		ammo_setting_table[2].CRC = nil
		ammo_setting_table[2].CRR = nil
		ammo_setting_table[3].LCT = false
		ammo_setting_table[3].CRC = false
		ammo_setting_table[3].CRR = false
		
		player.gui.left.at_on_off_table.destroy()	
	else
		setting = player.gui.left.add{type = "button", name = "at_setting", style = "at_setting_button_style"}
	end
	
	
	
	
	
end

function ammo_selected_button(event, list)
	if not (string.find(event.element.name, "frame") or string.find(event.element.name, "textfield")) then
		local name = string.sub(event.element.name, 4, 6)
		-- writeDebug(name)
		local ammo_type = ammo_filter(name)
		
		local frame1 = string.format("at_%s_checkbox_frame", name)
		local frame2 = string.format("at_%s_checkbox_frame_table", name)
		
		for _, ammo_name in pairs(ammo_type) do -- children_names?
			local frame3 = string.format("at_%s_%s", name, ammo_name[1])
			
			-- writeDebug(name .. " / " .. frame1 .. " / " .. frame2 .. " / " .. frame3)
			
			-- at_button.at_checkbox_frame.at_[3]_checkbox_frame.at_[3]_checkbox_frame_table.at_[3]_[ammo name]
			game.players[event.player_index].gui.left.at_button.at_checkbox_frame[frame1][frame2][frame3].style = "at_select_style"
		end
		event.element.style = "at_selected_style"
		ammo_setting_table[2][name] = string.sub(event.element.name, 8)
		-- writeDebug(string.sub(event.element.name, 4, 6) .. " / " .. string.sub(event.element.name, 8) .. " / " .. ammo_setting_table[2][(string.sub(event.element.name, 4, 6))])
	end
end

function save_button(player)
	local setting = player.gui.left["at_setting"]
	local button = player.gui.left["at_button"]
	
	-- writeDebug("1" .. ammo_setting_table[1].LCT .. " / " .. ammo_setting_table[1].CRC .. " / " .. ammo_setting_table[1].CRR)
	-- writeDebug("1" .. ammo_setting_table[2].LCT .. " / " .. ammo_setting_table[2].CRC .. " / " .. ammo_setting_table[2].CRR)
	
	if ammo_setting_table[3].LCT and ammo_setting_table[2].LCT then
		ammo_setting_table[1].LCT = ammo_setting_table[2].LCT
	end
	if ammo_setting_table[3].CRC and ammo_setting_table[2].CRC then
		ammo_setting_table[1].CRC = ammo_setting_table[2].CRC
	end
	if ammo_setting_table[3].CRR and ammo_setting_table[2].CRR then
		ammo_setting_table[1].CRR = ammo_setting_table[2].CRR
	end
	
	-- writeDebug("2" .. ammo_setting_table[1].LCT .. " / " .. ammo_setting_table[1].CRC .. " / " .. ammo_setting_table[1].CRR)
	-- writeDebug("2" .. ammo_setting_table[2].LCT .. " / " .. ammo_setting_table[2].CRC .. " / " .. ammo_setting_table[2].CRR)
	
	if button.at_radio_frame["at_radio_all"].state then
		
		for _, turret in pairs(global.Artillery_Table) do
			if turret[1].name == "at_LC_turret" and ammo_setting_table[3].LCT then
				turret[2].clear_request_slot(1)
				turret[2].set_request_slot({name = ammo_setting_table[1].LCT, count = ammo_setting_table[4].LCT}, 1)
				-- writeDebug("all_LCT t")
			elseif turret[1].name == "at_CR_turret" then
				if ammo_setting_table[3].CRC then
					turret[3][1][2].clear_request_slot(1)
					turret[3][1][2].set_request_slot({name = ammo_setting_table[1].CRC, count = ammo_setting_table[4].CRC}, 1)
					-- writeDebug("all_CRC t")
				end
				if ammo_setting_table[3].CRR then
					turret[3][2][2].clear_request_slot(1)
					turret[3][2][2].set_request_slot({name = ammo_setting_table[1].CRR, count = ammo_setting_table[4].CRR}, 1)
					-- writeDebug("all_CRR t")
				end
			end
		end
		
	elseif button.at_radio_frame["at_radio_near"].state then
	
		-- at_button	at_checkbox_frame	at_CRC_checkbox_frame	at_checkbox_CRC_table
		local checker1 = button.at_checkbox_frame.at_LCT_checkbox_frame.at_checkbox_LCT_table.at_checkbox_LCT
		local checker2 = button.at_checkbox_frame.at_CRC_checkbox_frame.at_checkbox_CRC_table.at_checkbox_CRC
		local checker3 = button.at_checkbox_frame.at_CRR_checkbox_frame.at_checkbox_CRR_table.at_checkbox_CRR
		
		if checker1.state or checker2.state or checker3.state then
			local frame_table = player.gui.left.add{type = "table", name = "at_on_off_table", colspan = 1}
			local icon_frames = frame_table.add{type = "frame", name = "at_on_off_icon", direction = "horizontal"}
			local button_frame = frame_table.add{type = "frame", name = "at_on_off_button", direction = "horizontal"}
			
			if checker1.state and ammo_setting_table[3].LCT then
				local icon_frame = icon_frames.add{type = "frame", name = "at_on_off_LCT_frame", direction = "vertical"}
				icon_frame.add{type = "sprite", name = "at_on_off_script_LCT", sprite = "item/at_LC_turret_area", tooltip = game.item_prototypes["at_LC_turret_area"].localised_name}
				icon_frame.add{type = "sprite", name = "at_on_off_script_LCT"..ammo_setting_table[1].LCT, sprite = "item/"..ammo_setting_table[1].LCT, tooltip = game.item_prototypes[ammo_setting_table[1].LCT].localised_name}
				number_gen(icon_frame)
			end
			if checker2.state and ammo_setting_table[3].CRC then
				local icon_frame = icon_frames.add{type = "frame", name = "at_on_off_CRC_frame", direction = "vertical"}
				icon_frame.add{type = "sprite", name = "at_on_off_script_CRC", sprite = "item/at_CR_turret_area", tooltip = game.item_prototypes["at_CR_turret_area"].localised_name}
				icon_frame.add{type = "sprite", name = "at_on_off_script_CRC"..ammo_setting_table[1].CRC, sprite = "item/"..ammo_setting_table[1].CRC, tooltip = game.item_prototypes[ammo_setting_table[1].CRC].localised_name}
				number_gen(icon_frame)
			end
			if checker3.state and ammo_setting_table[3].CRR then
				local icon_frame = icon_frames.add{type = "frame", name = "at_on_off_CRR_frame", direction = "vertical"}
				icon_frame.add{type = "sprite", name = "at_on_off_script_CRR", sprite = "item/at_CR_turret_area", tooltip = game.item_prototypes["at_CR_turret_area"].localised_name}
				icon_frame.add{type = "sprite", name = "at_on_off_script_CRR"..ammo_setting_table[1].CRR, sprite = "item/"..ammo_setting_table[1].CRR, tooltip = game.item_prototypes[ammo_setting_table[1].CRR].localised_name}
				number_gen(icon_frame)
			end
			
			
			button_frame.add{type = "button", name = "at_button_stop", caption = "STOP"}
			button_frame.add{type = "button", name = "at_button_view", caption = "View range"}
		end
	end
	
	if button then
		button.destroy()
	end
	if setting then
		setting.destroy()
	end
end

function expand_button(player)
	local button = player.gui.left["at_button"]
	if button then
		button.destroy()
		player.gui.left["at_setting"].destroy()
	else
		button = player.gui.left.add{type = "frame", name = "at_button", direction = "vertical"}
			button.add{type = "frame", name = "at_radio_frame", direction = "vertical"}
				button.at_radio_frame.add{type = "radiobutton", name = "at_radio_all", state = true, caption = "Change the request slot of the selected all turrets at the bottom."}
				button.at_radio_frame.add{type = "radiobutton", name = "at_radio_near", state = false, caption = "Change the request slot of the selected nearby turrets at the bottom."}
		
			button.add{type = "frame", name = "at_checkbox_frame", direction = "vertical"}
				local checkbox_frame = button.at_checkbox_frame.add{type = "frame", name = "at_LCT_checkbox_frame", direction = "vertical"}
					checkbox_frame.add{type = "table", name = "at_checkbox_LCT_table", colspan = 2}
						checkbox_frame.at_checkbox_LCT_table.add{type = "sprite", name = "at_checkbox_LCT_sprite", sprite = "item/at_LC_turret_area", tooltip = game.item_prototypes["at_LC_turret_area"].localised_name}
						checkbox_frame.at_checkbox_LCT_table.add{type = "checkbox", name = "at_checkbox_LCT", state = false, caption = "Set Capsule flower inventory."}
					Add_list(checkbox_frame)
					checkbox_frame.add{type = "table", name = "at_textfield_LCT_frame", colspan = 2}
						checkbox_frame.at_textfield_LCT_frame.add{type = "label", name = "at_LCT_label_textfield", caption = "COUNT :"}
						checkbox_frame.at_textfield_LCT_frame.add{type = "textfield", name = "at_LCT_input_textfield", text = ammo_setting_table[4].LCT}
				
				
				checkbox_frame = button.at_checkbox_frame.add{type = "frame", name = "at_CRC_checkbox_frame", direction = "vertical"}
					checkbox_frame.add{type = "table", name = "at_checkbox_CRC_table", colspan = 2}
						checkbox_frame.at_checkbox_CRC_table.add{type = "sprite", name = "at_checkbox_CRC_sprite", sprite = "item/at_CR_turret_area", tooltip = game.item_prototypes["at_CR_turret_area"].localised_name}
						checkbox_frame.at_checkbox_CRC_table.add{type = "checkbox", name = "at_checkbox_CRC", state = false, caption = "Set Destroyer inventory(shell)."}
					Add_list(checkbox_frame)
					checkbox_frame.add{type = "table", name = "at_textfield_CRC_frame", colspan = 2}
						checkbox_frame.at_textfield_CRC_frame.add{type = "label", name = "at_CRC_label_textfield", caption = "COUNT :"}
						checkbox_frame.at_textfield_CRC_frame.add{type = "textfield", name = "at_CRC_input_textfield", text = ammo_setting_table[4].CRC}
				
				
				checkbox_frame = button.at_checkbox_frame.add{type = "frame", name = "at_CRR_checkbox_frame", direction = "vertical"}
					checkbox_frame.add{type = "table", name = "at_checkbox_CRR_table", colspan = 2}
						checkbox_frame.at_checkbox_CRR_table.add{type = "sprite", name = "at_checkbox_CRR_sprite", sprite = "item/at_CR_turret_area", tooltip = game.item_prototypes["at_CR_turret_area"].localised_name}
						checkbox_frame.at_checkbox_CRR_table.add{type = "checkbox", name = "at_checkbox_CRR", state = false, caption = "Set Destroyer inventory(rocket)."}
					Add_list(checkbox_frame)
					checkbox_frame.add{type = "table", name = "at_textfield_CRR_frame", colspan = 2}
						checkbox_frame.at_textfield_CRR_frame.add{type = "label", name = "at_CRR_label_textfield", caption = "COUNT :"}
						checkbox_frame.at_textfield_CRR_frame.add{type = "textfield", name = "at_CRR_input_textfield", text = ammo_setting_table[4].CRR}
		
			button.add{type = "button", name = "at_save_button", caption = "Apply"}
		
	end
end

function Add_list(frame)
	local ammo_type = ammo_filter(frame.name)
	
	-- writeDebug(#ammo_type)
	local icon_frame = frame.add{type = "table", name = frame.name .. "_table", colspan = #ammo_type}
	for _, ammo_name in pairs(ammo_type) do
		icon_frame.add{type = "sprite-button", name = string.sub(frame.name, 1, 7)..ammo_name[1], sprite = "item/"..ammo_name[1], style = "at_select_style", tooltip = game.item_prototypes[ammo_name[1]].localised_name}
		-- writeDebug("item/"..ammo_name[1] .. " / " .. string.sub(frame.name, 1, 15)..ammo_name[1])
	end
end

function finish_button(player)
	
	ammo_setting_table[2].LCT = nil
	ammo_setting_table[2].CRC = nil
	ammo_setting_table[2].CRR = nil
	ammo_setting_table[3].LCT = false
	ammo_setting_table[3].CRC = false
	ammo_setting_table[3].CRR = false
	
	player.gui.left.at_on_off_table.destroy()
end
------------------------------
function view_area(player)
	
	local pos = player.position
	local range = 25
	
	for i = 1, 2 do
		for j = 0, math.floor(range/5 - 1) do
			local start_x, start_y, target_x, target_y
			local k = 1
			if i == 2 then k = -1 end
			
			start_x = pos.x - (range - range * 2 / math.floor(range/5) * j) * k
			start_y = pos.y - range * k
			target_x = pos.x - (range - range * 2 / math.floor(range/5) * (j + 1)) * k
			target_y = pos.y - range * k
			player.surface.create_entity({name = "guid-flash", position = {x = start_x, y = start_y}, force = player.force, target = {x = target_x, y = target_y}, speed = 0.1})
			
			start_x = pos.x + range * k
			start_y = pos.y - (range - range * 2 / math.floor(range/5) * j) * k
			target_x = pos.x + range * k
			target_y = pos.y - (range - range * 2 / math.floor(range/5) * (j + 1)) * k
			player.surface.create_entity({name = "guid-flash", position = {x = start_x, y = start_y}, force = player.force, target = {x = target_x, y = target_y}, speed = 0.1})
		end
	end
end

function change_request_chest(player)
	-- writeDebug("change on")
	local pos = player.position
	local range = 25
	local unit = player.surface.find_entities_filtered({area = {{x = pos.x - range, y = pos.y - range}, {x = pos.x + range, y = pos.y + range}}, type = "logistic-container"})
	if #unit > 0 then
		for _, logistic_container in pairs(unit) do
			if logistic_container.name == "at_LC_turreti" and ammo_setting_table[3].LCT then
				logistic_container.clear_request_slot(1)
				logistic_container.set_request_slot({name = ammo_setting_table[1].LCT, count = ammo_setting_table[4].LCT}, 1)
			elseif logistic_container.name == "at_CR_turreti_1" and ammo_setting_table[3].CRC then
				logistic_container.clear_request_slot(1)
				logistic_container.set_request_slot({name = ammo_setting_table[1].CRC, count = ammo_setting_table[4].CRC}, 1)
			elseif logistic_container.name == "at_CR_turreti_2" and ammo_setting_table[3].CRR then
				logistic_container.clear_request_slot(1)
				logistic_container.set_request_slot({name = ammo_setting_table[1].CRR, count = ammo_setting_table[4].CRR}, 1)
			end
			-- writeDebug(logistic_container.name)
		end
		-- writeDebug("unit = " .. #unit)
	end
end

function number_holic(event)
	-- writeDebug(type(event.element.text))
	local text = tonumber(event.element.text)
	if type(text) == "number" then
		if text > 0 and text <= 75 then
			ammo_setting_table[4][string.sub(event.element.name, 4, 6)] = text
		elseif text > 75 then
			ammo_setting_table[4][string.sub(event.element.name, 4, 6)] = 75
		end
	else
		ammo_setting_table[4][string.sub(event.element.name, 4, 6)] = 20
	end
end

function ammo_filter(input)
	local ammo_output = {}
	
	if string.find(input, "LCT") then
		ammo_output = ammo_list.capsules
	elseif string.find(input, "CRC") then
		ammo_output = ammo_list.shells
		for i = 1, #ammo_output do
			for index, name in pairs(ammo_output) do
				if name[1] == "cannon-shell" or name[1] == "explosive-cannon-shell" then
					table.remove(ammo_output, index)
					break
				end
			end
		end
	elseif string.find(input, "CRR") then
		ammo_output = ammo_list.rockets
	end
	return ammo_output
end

function number_gen(frame)
	local number
	local name
	if string.find(frame.name, "LCT") then
		number = ammo_setting_table[4].LCT
		name = "LCT"
	elseif string.find(frame.name, "CRC") then
		number = ammo_setting_table[4].CRC
		name = "CRC"
	elseif string.find(frame.name, "CRR") then
		number = ammo_setting_table[4].CRR
		name = "CRR"
	end
	
	frame.add{type = "table", name = "at_on_off_script_LCT_table", colspan = 2}
	if number < 10 then
		number = number + 100
	end
	frame.at_on_off_script_LCT_table.add{type = "sprite", name = "at_on_off_script_"..name.."_number_2", sprite = "number_"..tostring(math.floor(number / 10))}
	frame.at_on_off_script_LCT_table.add{type = "sprite", name = "at_on_off_script_"..name.."_number_1", sprite = "number_"..tostring(number % 10)}
end
------------------------------
function On_Built(event)
	local entity = event.created_entity
	local surface = entity.surface
	local force = entity.force
	local position = entity.position
	local check = 0
	
	if global.Artillery_Table == nil then
		global.Artillery_Table = {}
		Event.register(defines.events.on_tick, function(event) end)
	end
	
	-- Artillery has been built
	if entity.name == "at_Artillery_mk2_area" then
	
		-- writeDebug("Artillery has been built")
		
		for _, turret_name in pairs (global.Artillery_Table) do
			if turret_name[1].name == "at_Artillery_mk2" then
				check = check + 1
			end
		end
		
		-- writeDebug("check = " .. check)
		if check > 9 then
			event.created_entity.destroy()
			writeDebug("Experimental heavy howitzer : Not built over 10")
			local player = game.players[event.player_index]
			player.insert({name = "at_Artillery_mk2_area"})
		else
			local New_Artillery = surface.create_entity({name = "at_Artillery_mk2", position = position, direction = event.created_entity.direction, force = force})
			local New_ArtilleryI = surface.create_entity({name = "at_Artillery_mk2".."i", position = position, direction = event.created_entity.direction, force = force})
			local New_ArtilleryR = surface.create_entity({name = "at_Artillery_mk2".."r", position = position, direction = event.created_entity.direction, force = force})
			
			event.created_entity.destroy()
			
			New_Artillery.destructible = false
			New_Artillery.operable = false
			New_Artillery.minable = false
			
			New_ArtilleryI.operable = true
			New_ArtilleryI.minable = true
			
			New_ArtilleryR.operable = false
			New_ArtilleryR.destructible = false
			New_ArtilleryR.minable = false
			
			table.insert(global.Artillery_Table, {New_Artillery,New_ArtilleryI,New_ArtilleryR,3,{1, 0, 0},0})
			-- global.Artillery_Table(turret, turretInventory, turretCustom, delay, scanPosition(D, L, F), noEnemy)
		end
		
	elseif entity.name == "at_LC_turret_area" then
		
		for _, turret_name in pairs (global.Artillery_Table) do
			if turret_name[1].name == "at_LC_turret" then
				check = check + 1
			end
		end
		
		if check > 99 then
			event.created_entity.destroy()
			writeDebug("Capsule flower : Not built over 100")
			local player = game.players[event.player_index]
			player.insert({name = "at_LC_turret_area"})
		else
			
			local New_LC = surface.create_entity({name = "at_LC_turret", position = position, direction = event.created_entity.direction, force = force})
			local New_LCI = surface.create_entity({name = "at_LC_turret".."i", position = position, direction = event.created_entity.direction, force = force})
			
			New_LCI.set_request_slot({name = ammo_setting_table[1].LCT, count = ammo_setting_table[4].LCT}, 1) 
			
			local i = 1
			local j = 1
			local New_LCL = {}
			
			for k = 1, 4 do
				if k%2 == 1 then
					i = i * -1
				else
					j = j * -1
				end
				local LC_offset = 1.7
				local position_offset = {position.x + LC_offset * i , position.y + LC_offset * j }
				local LCL = surface.create_entity({name = "at_LC_turret".."l", position = position_offset, direction = event.created_entity.direction, force = force})
				
				LCL.operable = false
				LCL.destructible = true
				LCL.minable = false
				
				table.insert(New_LCL, {k, LCL})
				
			end
			
			event.created_entity.destroy()
			
			New_LC.destructible = false
			New_LC.operable = false
			New_LC.minable = false
			
			New_LCI.destructible = false
			New_LCI.operable = true
			New_LCI.minable = true
			
			table.insert(global.Artillery_Table, {New_LC,New_LCI,New_LCL,3,0,0})
			-- global.Artillery_Table(turret, turretInventory, turretCustom, delay, -, -)
		end
		
	elseif entity.name == "at_CR_turret_area" then
		
		for _, turret_name in pairs (global.Artillery_Table) do
			if turret_name[1].name == "at_CR_turret" then
				check = check + 1
			end
		end
		
		if check > 99 then
			event.created_entity.destroy()
			writeDebug("Destroyer : Not built over 100")
			local player = game.players[event.player_index]
			player.insert({name = "at_CR_turret_area"})
		else
			
			local New_CR = surface.create_entity({name = "at_CR_turret", position = position, direction = event.created_entity.direction, force = force})
			local New_CRR = surface.create_entity({name = "at_CR_turret".."r", position = position, direction = event.created_entity.direction, force = force})
			
			local New_CRI = {}
			
			for k = 1, 2 do
				local i = 1
				if k%2 == 1 then
					i = i * -1
				end
				local LC_offset = 1.5
				local position_offset = {position.x + LC_offset * i , position.y + 1.5 }
				local CRI = surface.create_entity({name = "at_CR_turret".."i_"..k, position = position_offset, direction = event.created_entity.direction, force = force})
				
				CRI.operable = true
				CRI.destructible = false
				CRI.minable = false
				
				if k == 1 then
					CRI.set_request_slot({name = ammo_setting_table[1].CRC, count = ammo_setting_table[4].CRC}, 1)
				else
					CRI.set_request_slot({name = ammo_setting_table[1].CRR, count = ammo_setting_table[4].CRR}, 1)
				end
				
				table.insert(New_CRI, {1, CRI})
			end
			
			event.created_entity.destroy()
			
			New_CR.destructible = false
			New_CR.operable = false
			New_CR.minable = false
			
			New_CRR.destructible = true
			New_CRR.operable = false
			New_CRR.minable = true
			
			New_CR.active = false
			New_CRR.active = false
			
			table.insert(global.Artillery_Table, {New_CR,New_CRR,New_CRI,3,{0,0},1})
			-- global.Artillery_Table(turret, turretInventory, turretCustom, delay, inventoryChecker{cannon,rocket}, -)
		end
		
	elseif entity.name == "at_Artillery_mk1_area" or entity.name == "at_Artillery_mk1" then
	
		-- writeDebug("Artillery has been built")
		
		for _, turret_name in pairs (global.Artillery_Table) do
			if turret_name[1].name == "at_Artillery_mk1" then
				check = check + 1
			end
		end
		
		-- writeDebug("check = " .. check)
		if check > 49 then
			event.created_entity.destroy()
			writeDebug("Heavy howitzer : Not built over 50")
			local player = game.players[event.player_index]
			player.insert({name = "at_Artillery_mk1_area"})
		else
			local New_Artillery = surface.create_entity({name = "at_Artillery_mk1", position = position, direction = event.created_entity.direction, force = force})
			local New_ArtilleryI = surface.create_entity({name = "at_Artillery_mk1".."i", position = position, direction = event.created_entity.direction, force = force})
			local New_ArtilleryR = surface.create_entity({name = "at_Artillery_mk1".."r", position = position, direction = event.created_entity.direction, force = force})
			
			event.created_entity.destroy()
			
			New_Artillery.destructible = false
			New_Artillery.operable = false
			New_Artillery.minable = false
			
			New_ArtilleryI.operable = true
			New_ArtilleryI.minable = true
			
			New_ArtilleryR.operable = false
			New_ArtilleryR.destructible = false
			New_ArtilleryR.minable = false
			
			table.insert(global.Artillery_Table, {New_Artillery,New_ArtilleryI,New_ArtilleryR,3,{1, 0, 0},0})
			-- global.Artillery_Table(turret, turretInventory, turretCustom, delay, scanPosition(D, L, F), noEnemy)
		end
		
	end
end

-- Artillery Stuff


function Artillery_health_check(Artillery_List)
	
	local health_level = 300
	
	if Artillery_List[1].name == "at_LC_turret" then
		
		for i = 1, #Artillery_List[3] do
			
			local position = Artillery_List[1].position
			local LC_offset = 1.7
			local x = 1
			local y = 1
			
			if Artillery_List[3][i][2].valid then
				if Artillery_List[3][i][2].name == "at_LC_turretl" then
					health_level = health_level + Artillery_List[3][i][2].health
				end
			else
				for k = 1, i do
					if k%2 == 1 then
						x = x * -1
					else
						y = y * -1
					end
				end
				
				local position_offset = {position.x + LC_offset * x , position.y + LC_offset * y }
				local LCC = Artillery_List[1].surface.create_entity({name = "at_LC_turret".."c", position = position_offset, force = Artillery_List[1].force})
				
				LCC.health = 1
				LCC.operable = false
				LCC.destructible = false
				LCC.minable = false
				Artillery_List[3][i][2] = LCC
				
			end
			
			if Artillery_List[3][i][2].name == "at_LC_turretc" and Artillery_List[3][i][2].health >= 700 then
				Artillery_List[3][i][2].destroy()
				for k = 1, i do
					if k%2 == 1 then
						x = x * -1
					else
						y = y * -1
					end
				end
				
				local position_offset = {position.x + LC_offset * x , position.y + LC_offset * y }
				local LCL = Artillery_List[1].surface.create_entity({name = "at_LC_turret".."l", position = position_offset, force = Artillery_List[1].force})
				
				LCL.health = 250
				LCL.operable = false
				LCL.destructible = true
				LCL.minable = false
				Artillery_List[3][i][2] = LCL
				
			end
		end
		if health_level <= 300 then
			Artillery_List[1].surface.create_entity({name = "cluster-grenade", position = Artillery_List[1].position, force = Artillery_List[1].force, target = Artillery_List[1].position, speed = 1})
			Artillery_List[1].surface.create_entity({name = "cluster-grenade", position = Artillery_List[1].position, force = Artillery_List[1].force, target = Artillery_List[1].position, speed = 1})
			Artillery_List[2].destroy()
		else
			Artillery_List[1].health = health_level
		end
		
	elseif Artillery_List[1].name == "at_CR_turret" then
		if Artillery_List[2].health == 0 then
			Artillery_List[2].destroy()
			Artillery_List[1].surface.create_entity({name = "cluster-grenade", position = Artillery_List[1].position, force = Artillery_List[1].force, target = Artillery_List[1].position, speed = 1})
		end
	end
end

function Artillery_destroy(Artillery_List)
	
	--return inventory item in CR turret (C)
	if global.Recall_player ~= nil then
		if Artillery_List[1].name == "at_CR_turret" then
			local player_index = global.Recall_player[1]
			table.remove(global.Recall_player, 1)
			if #global.Recall_player == 0 then
				global.Recall_player = nil
			end

			local inventory = Artillery_List[1].get_inventory(1)
			local inv_cont = inventory.get_contents()
			local player = game.players[player_index]
			for n,a in pairs(inv_cont) do
				local AmmoName = n
				local ammo = a
				player.insert({name = AmmoName, count = ammo})
			end
		end
	end
	
	if Artillery_List[1].valid then
		Artillery_List[1].destroy()
	end
	if #Artillery_List[2] >= 1 then
		for i = 1, #Artillery_List[2] do
			if Artillery_List[2][i][2].valid then
				Artillery_List[2][i][2].destroy()
			end
		end
	else
		if Artillery_List[2].valid then
			Artillery_List[2].destroy()
		end
	end
	if #Artillery_List[3] >= 1 then
		for i = 1, #Artillery_List[3] do
			if Artillery_List[3][i][2].valid then
				Artillery_List[3][i][2].destroy()
			end
		end
	else
		if Artillery_List[3].valid then
			Artillery_List[3].destroy()
		end
	end
end

function Artillery_scanner(name, check, attack_counter)
	
	local function scanner_calculator(temp_grid, temp_check)
		
		local x, y
		if temp_check[1] == 1 then
			x = - (temp_grid[1] + temp_grid[2] * temp_check[3]) + temp_grid[2] * temp_check[2]
			y = - (temp_grid[1] + temp_grid[2] * temp_check[3])
		elseif temp_check[1] == 2 then
			x = (temp_grid[1] + temp_grid[2] * temp_check[3]) - temp_grid[2]
			y = - (temp_grid[1] + temp_grid[2] * temp_check[3]) + temp_grid[2] * temp_check[2]
		elseif temp_check[1] == 3 then
			x = (temp_grid[1] + temp_grid[2] * temp_check[3]) - temp_grid[2] - temp_grid[2] * temp_check[2]
			y = (temp_grid[1] + temp_grid[2] * temp_check[3]) - temp_grid[2]
		elseif temp_check[1] == 4 then
			x = - (temp_grid[1] + temp_grid[2] * temp_check[3])
			y = (temp_grid[1] + temp_grid[2] * temp_check[3]) - temp_grid[2] - temp_grid[2] * temp_check[2]
		end
		
		return x, y
	end
	
	local grid
	local scan_direction = check[1]
	local scan_level = check[2]
	local scan_interval = check[3]
	-- scan_direction = 1(right) 2(down) 3(left) 4(up) / scan_level = 0(check) 1 2 3 4 5 6 7... / scan_interval = [near|0 1 2 3 4 5 ...|far]
	
	if name == "at_Artillery_mk1" then
		
		grid = {150, 50, 300}
		--{grid, gap, max_range}
	
	elseif name == "at_Artillery_mk2" then
		
		grid = {200, 100, 500}
	
	end
	local temp_scan_direction
	if scan_direction == 4 then
		temp_scan_direction = 1
	else
		temp_scan_direction = scan_direction + 1
	end
	local temp_x, temp_y = scanner_calculator(grid, {temp_scan_direction, 0, scan_interval})
	local x1, y1 = scanner_calculator(grid, check)
	
	-- writeDebug("x1 / y1 = " .. x1 .. " / " .. y1 .. " | temp x / y = " .. temp_x .. " / " .. temp_y)
	
	scan_level = scan_level + 1
	
	if scan_level > 0 then
		
		if x1 == temp_x and y1 == temp_y then
			
			scan_direction = scan_direction + 1
			scan_level = 1
			if scan_direction > 4 then
				scan_direction = 1
				if attack_counter == 0 then
					scan_interval = scan_interval + 1
					attack_counter = 0
					if grid[1] + grid[2] * scan_interval > grid[3] then
						scan_interval = 0
					end
				else
					scan_interval = 0
					attack_counter = 0
				end
			end
		end
	end
	
	
	local x2 = x1 + grid[2]
	local y2 = y1 + grid[2]
	
	-- writeDebug(" | 1/2/3 = " .. scan_direction .. " / " .. scan_level .. " / " .. scan_interval)
	
	return x1, x2, y1, y2, {scan_direction, scan_level, scan_interval}, attack_counter
end


function Artillery_Check(Artillery_List)
	
	local Artillery = Artillery_List[1]
	local AmmoName_1
	local ammo_1 = 0
	local spawner
	local worm
	local marks
	local target
	local delay = 0
	
	if Artillery.name == "at_Artillery_mk1" or Artillery.name == "at_Artillery_mk2" then
	
		local Artilleryi = Artillery_List[2]
		local inventory_1 = Artilleryi.get_inventory(1)
		local inventoryContent_1 = inventory_1.get_contents()
		local number = 1
		if Artillery.name == "at_Artillery_mk2" then
			number = 2
		end
		local AmmoName_entity = ammo_list.artillery_shells[number][2]
		
		if inventoryContent_1 ~= nil then
			-- writeDebug("inventoryContent_1 check")
			for n,a in pairs(inventoryContent_1) do
				AmmoName_1 = n
				ammo_1 = a
			end
		end
		
		-- local filter = string.sub(Artillery.name, string.find(Artillery.name, "%d"))
		-- if filter ~= string.format("%d", number) then
			-- AmmoName_1 = ""
			-- ammo_1 = 0
		-- end
		
		if ammo_1 > 0 and Artillery_List[3].energy > 0 then	
		
			local pos = Artillery.position
			local x1, y1, x2, y2
			
			if type(Artillery_List[5]) ~= "table" then
				Artillery_List[5] = {1, 0, 0}
			end
			
			if Artillery_List[6] == nil then
				Artillery_List[6] = 0
			end
			
			x1, x2, y1, y2, Artillery_List[5], Artillery_List[6] = Artillery_scanner(Artillery.name, Artillery_List[5], Artillery_List[6])
			local area = {{pos.x + x1, pos.y + y1}, {pos.x + x2, pos.y + y2}}
			
			marks = {}
			if number == 2 then
				if global.listTarget ~= nil then
					marks = global.listTarget
				end
				-- writeDebug("marks = " .. #marks)
				-- Check Marks
				if #marks > 0 then
					for k,enemy in pairs(marks) do
						if enemy.valid == false then
							table.remove(global.listTarget, k)
							if #global.Artillery_Table == 0 then
								global.listTarget = nil
							end
							break
						end
						target = {enemy}
					end
				end
			end
			
			
			-- Find Spawner And Worm Target
			if target == nil then
				
				spawner = Artillery.surface.find_entities_filtered({area = area, type = "unit-spawner"})
				-- writeDebug("The Number of Spawners are: " .. #spawner)
				if #spawner > 0 then
					
					target = {spawner[math.random(#spawner)]}
					-- writeDebug("Finish Find Spawner Enemy")
					
				else
					
					worm = Artillery.surface.find_entities_filtered({area = area, type = "turret"})
					-- writeDebug("The Number of Worms are: " .. #worm)
					if #worm > 0 then
						target = {worm[math.random(#worm)]}
					end
					-- writeDebug("Finish Find Worm Enemy")
					
				end
			end
			

			-- Fire at Enemy
			if target ~= nil then
				Artillery_List[6] = Artillery_List[6] + 1
				if #marks > 0 then
					offsetR = 10
				else
					offsetR = 5
				end
				local offset1 = math.random(0,offsetR) * math.sin(math.random()*(math.pi*2))
				local offset2 = math.random(0,offsetR) * math.sin(math.random()*(math.pi*2))
				local offsetX = target[1].position.x + offset1
				local offsetY = target[1].position.y + offset2
				
				local newtarget = {offsetX, offsetY}
				-- writeDebug("Set Random Target")
				local speed = (((math.abs(pos.x - target[1].position.x) + offset1)^2 + (math.abs(pos.y - target[1].position.y) + offset2)^2)^0.5) / 240
				
				-- writeDebug("Start Fire")
				Artillery.surface.create_entity({name = "ammo-action", position = {x = pos.x, y = pos.y - 5.625}, force = Artillery.force, target = {x = pos.x, y = pos.y - 100}, speed = 2})
				Artillery.surface.create_entity({name = "ammo-shadow", position = {x = pos.x, y = pos.y}, force = Artillery.force, target = newtarget, speed = speed})
				Artillery.surface.create_entity({name = "muzzle-flash", position = {x = pos.x, y = pos.y - 5.625}, force = Artillery.force, target = {x = pos.x, y = pos.y - 5.25}, speed = 0.01})
				Artillery.surface.create_entity({name = AmmoName_entity, position = {x = offsetX, y = offsetY - 240}, force = Artillery.force, target = newtarget, speed = 1})
				Artillery.surface.create_entity({name = "at_Artillery_mk2_sound", position = pos})
				
				Artillery.surface.pollute(pos,1000*number^2)
				
				local units = Artillery.surface.find_enemy_units(newtarget, 30)
				for _, unit in pairs(units) do
					unit.set_command({type = defines.command.attack, target = Artillery})
				end
				
				-- Reduce Ammo
				ammo_1 = ammo_1 - 1
				inventory_1.clear()
				if ammo_1 > 0 then
					inventory_1.insert({name = AmmoName_1, count = ammo_1})
				end
				
				-- Delay between shots
				if #marks > 0 then
					delay = 3 * 10
				else
					delay = 3 * 25 -- 25
				end
				
			else
				delay = 3 * 2
			end
		end
		
	elseif Artillery.name == "at_LC_turret" then
		
		-- writeDebug("Loading at_LC_turret")
		local Artilleryi = Artillery_List[2]
	
		local inventory_1 = Artilleryi.get_inventory(1)
		local inventoryContent_1 = inventory_1.get_contents()
		local turret_inventory = Artillery.get_inventory(1)
		local AmmoName_entity
		delay = 1
		
		-- writeDebug(ammo_list.capsules[1][2])
		
		if not inventory_1.is_empty() then
			-- writeDebug("inventoryContent_1 check")
			AmmoName_1 = inventory_1[1].prototype.name
			ammo_1 = inventory_1[1].count
			
			local tr = 0
			for _, ammo in pairs(ammo_list.capsules) do
				if AmmoName_1 == ammo[1] then
					tr = 1
					AmmoName_entity = ammo[2]
				end
			end
			
			if ammo_1 > 0 and tr == 0 then
				AmmoName_1 = ""
				ammo_1 = 0
				inventory_1.clear()
				turret_inventory.clear()
				writeDebug("Capsule flower : Don't use this item. Available only Vanila capsules.")
			end
		end
		
		if ammo_1 == 0 then
			turret_inventory.clear()
		end
		
		if ammo_1 > 0 then
			
			turret_inventory.clear()
			turret_inventory.insert({name = "dummy_capsule", count = ammo_1})
			
			local range = 25
			local pos = Artillery.position
		
			if target == nil then
				target = Artillery.surface.find_nearest_enemy{position = pos, max_distance = range}
			end
			
			if target ~= nil then
				
				-- Attack Target
				Artillery.surface.create_entity({name = AmmoName_entity, position = pos, force = Artillery.force, target = target, speed = 0.75})
				Artillery.surface.create_entity({name = "at_LC_turret_sound", position = pos})
				
				Artillery.surface.pollute(pos,1000)
				
				-- Reduce Ammo
				ammo_1 = ammo_1 - 1
				-- inventory_1.clear()
				-- turret_inventory.clear()
				if ammo_1 > 0 then
					-- inventory_1.insert({name = AmmoName_1, count = ammo_1})
					turret_inventory[1].count = ammo_1
					inventory_1[1].count = ammo_1
				else
					inventory_1.clear()
					turret_inventory.clear()
				end
				
				-- Delay between shots
				delay = 3 * 2 -- 2
			end
		end
		
	elseif Artillery.name == "at_CR_turret" then
		
		-- writeDebug("CR_turret action")
		-- writeDebug("tick" .. game.tick)
		
		-- Find Spawner And Worm Target
		
		local Artilleryi_1 = Artillery_List[3][1][2]
		local Artilleryi_2 = Artillery_List[3][2][2]
		local inventory_1 = Artilleryi_1.get_inventory(1)
		local inventory_2 = Artilleryi_2.get_inventory(1)
		local turret_inventory_C = Artillery.get_inventory(1)
		local turret_inventory_R = Artillery_List[2].get_inventory(1)
		
		local ammo_2 = 0
		local minrange = 20
		local maxrange = 50
		delay = 1
		
		-- local body_direction = Artillery_List[1].direction
		-- writeDebug("turret rotation state = " .. Artillery_List[2].direction)
		-- direction = 0(north) ~ 7
		
		ammo_1, Artillery_List[5][1] = inventory_sync(inventory_1, turret_inventory_C, ammo_list.shells, Artillery_List[5][1])
		ammo_2, Artillery_List[5][2] = inventory_sync(inventory_2, turret_inventory_R, ammo_list.rockets, Artillery_List[5][2])
		
		-- if not turret_inventory_C.is_empty() then
			-- writeDebug("name = " .. turret_inventory_C[1].prototype.name .. " / count = " .. turret_inventory_C[1].count)
		-- else
			-- writeDebug("inv1 is empty")
		-- end
		
		if (ammo_1 + ammo_2) > 0 then
		
			local pos = Artillery.position
			target = Artillery.surface.find_enemy_units(pos, maxrange)
			
			-- Fire at Enemy
			if #target ~= 0 then
				-- writeDebug("Set Random Target pos / Fire / Reduce Ammo")
				
				if Artillery_List[6] == 0 then
					Artillery_List[6] = 1
					Artillery_List[1].active = false
					Artillery_List[2].active = false
					delay = 3 * 2
					Artillery.surface.create_entity({name = "flying-text", position = pos, text = "Reload Ammo 2s", color = {r = 0.7, g = 0.7}})
				else
					Artillery_List[6] = 0
					Artillery_List[1].active = true
					Artillery_List[2].active = true
					delay = 3 * 5
					Artillery.surface.create_entity({name = "flying-text", position = pos, text = "Fire!", color = {r = 1}})
				end
			end
		end
	end
	
	if delay == 0 then
		delay = 3 * 10
	end
	Artillery_List[4] = delay
end


-- DeBug Messages 
function writeDebug(message)
	for i, player in pairs(game.players) do
		player.print(tostring(message))
	end
end

function inventory_sync(req_inventory, turret_inventory, ammo_table, check)

	local AmmoName, t_AmmoName, ammo, t_ammo = nil, nil, 0, 0
	
	local inv_cont = req_inventory.get_contents()
	local turret_inv_cont = turret_inventory.get_contents()
	
	-- writeDebug("inventory sync start")
	
	for n,a in pairs(inv_cont) do
		AmmoName = n
		ammo = a
	end
	
	for n,a in pairs(turret_inv_cont) do
		t_AmmoName = n
		t_ammo = a
	end
	
	local tr = 0
	for _, a in pairs(ammo_table) do
		if AmmoName == a[1] then
			tr = 1
			break
		end
	end
	
	if (AmmoName == "cannon-shell") or (AmmoName == "explosive-cannon-shell") then
		tr = 0
	end
	
	if ammo > 0 and tr == 0 then
		AmmoName = ""
		ammo = 0
		req_inventory.clear()
		turret_inventory.clear()
		check = 0
		writeDebug("Destroyer : Don't use this item. Only registered items can be used.")
	end
	
	if ammo == 0 then
		AmmoName = ""
		ammo = 0
		turret_inventory.clear()
		check = 0
	end
	
	if ammo > 0 then
		
		check = ammo + t_ammo - check
		
		if t_ammo ~= ammo then
			turret_inventory.clear()
			req_inventory.clear()
			
			-- writeDebug("t_ammo = " .. t_ammo)
			
			if (t_ammo ~= 0) or (check ~= 0) then
			
				turret_inventory.insert({name = AmmoName, count = check})
				req_inventory.insert({name = AmmoName, count = check})
			end
			
		end
		
		ammo = check
		
	end
	-- writeDebug("ammo check : inventory / turret / check " .. req_inventory[1].count .. " / " .. turret_inventory[1].count .. " / " .. check)
	
	return ammo, check

end

function AddMark(event)
-- writeDebug("Making Target")
	if event.entity.name == 'target-cloud' then
		if global.listTarget == nil then
			global.listTarget = {}
		end
		table.insert(global.listTarget, event.entity)
		event.entity.surface.create_entity({name = "capsule_sound", position = event.entity.position})
		-- writeDebug("Insert Target")
	end
end

function Recall_Items(event)
-- writeDebug("Recall_Items")
	if event.entity.name == "at_CR_turretr" then
		if global.Recall_player == nil then
			global.Recall_player = {}
		end
		table.insert(global.Recall_player, event.player_index)
		-- writeDebug(event.player_index)
	end
end