local at_Artillery_mk1_shift = {0.5, -2.25}
local at_Artillery_mk2_shift = {0.5, -2.25}


function at_Artillery_mk1_attack(inputs)
return
{
	layers = 
	{
		{
			filename = "__Additional-Turret__/graphics/entity/artillery-big-mk1-attack.png",
			priority = "medium",
			width = 260,
			height = 295,
			direction_count = 1,
			frame_count = 1,
			axially_symmetrical = false,
			shift = at_Artillery_mk1_shift,
		}
	}
}
end

function at_Artillery_mk2_attack(inputs)
return
{
	layers = 
	{
		{
			filename = "__Additional-Turret__/graphics/entity/artillery-big-mk2-attack.png",
			priority = "medium",
			width = 260,
			height = 295,
			direction_count = 1,
			frame_count = 1,
			axially_symmetrical = false,
			shift = at_Artillery_mk2_shift,
		}
	}
}
end

function blank(inputs)
return
{
	layers = 
	{
		{
			filename = "__base__/graphics/terrain/blank.png",
			priority = "medium",
			width = 1,
			height = 1,
			direction_count = 1,
			frame_count = 1,
			axially_symmetrical = false,
			shift = at_Artillery_mk2_shift,
		}
	}
}
end



data:extend({

--Range Overlay
{
	type = "ammo-turret",
	name = "at_Artillery_mk1_area",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk1-icon.png",
	flags = {"placeable-neutral", "placeable-player", "player-creation"},
	order = "b[turret]-d[artillery]-a[heavy]",
	max_health = 1200,
	corpse = "big-remnants",
	dying_explosion = "massive-explosion",
	
	collision_box = {{ -3.7, -2.7}, {3.7, 2.7}},
	selection_box = {{ -4, -3}, {4, 3}},
	
	folding_speed = 0.04,
	inventory_size = 1,
	automated_ammo_count = 10,
	
	folded_animation = at_Artillery_mk1_attack{},
	folding_animation = at_Artillery_mk1_attack{},

	attack_parameters =
	{
		type = "projectile",
		ammo_category = "artillery-mk1-shell",
		cooldown = 1500,
		range = 200,
		min_range = 100,
		projectile_creation_distance = 1.8,
		action ={},
	},
	call_for_help_radius = 40
},

--Artillery
{
	type = "container",
	name = "at_Artillery_mk1",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk1-icon.png",
	flags = {"placeable-neutral", "player-creation", "placeable-off-grid", "not-repairable"},
	minable = { mining_time = 10, result = "at_Artillery_mk1_area" },
	selectable_in_game = false,
	max_health = 1200,
	corpse = "big-remnants",
	dying_explosion = "big-explosion",
	collision_box = {{ 0, 0}, {0, 0}},
	selection_box = {{ 0, 0}, {0, 0}},
	order = "b[turret]-d[artillery]-a[heavy]",
	inventory_size = 1,
	
	picture = blank{},

	call_for_help_radius = 40
},

--Inventory
{
	type = "ammo-turret",
	name = "at_Artillery_mk1i",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk1-icon.png",
	flags = {"placeable-neutral", "placeable-player", "player-creation"},
	minable = { mining_time = 10, result = "at_Artillery_mk1_area" },
	order = "b[turret]-d[artillery]-a[heavy]",
	open_sound = { filename = "__Additional-Turret__/sound/Artillery_mk2_sound_open.ogg", volume=0.9 },
	max_health = 1200,
	corpse = "big-remnants",
	dying_explosion = "massive-explosion",
	collision_box = {{ -3.7, -2.7}, {3.7, 2.7}},
	selection_box = {{ -4, -3}, {4, 3}},
	folding_speed = 0.04,
	inventory_size = 1,
	automated_ammo_count = 10,
	
	folded_animation = at_Artillery_mk1_attack{},
	folding_animation = at_Artillery_mk1_attack{},
	
	vehicle_impact_sound =	{ filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },

	attack_parameters =
	{
		type = "projectile",
		ammo_category = "artillery-mk1-shell",
		cooldown = 1500,
		range = 0,
		projectile_creation_distance = 1.8,
		action ={},
	},
	call_for_help_radius = 40
},

--Radar
{
	type = "radar",
	name = "at_Artillery_mk1r",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk1-icon.png",
	flags = {"placeable-neutral", "player-creation", "placeable-off-grid", "not-repairable"},
	selectable_in_game = false,
	minable = {mining_time = 10, result = "at_Artillery_mk1_area"},
	max_health = 1200,
	corpse = "big-remnants",
	dying_explosion = "massive-explosion",
	collision_box = {{ 0, 0}, {0, 0}},
	selection_box = {{ 0, 0}, {0, 0}},
	order = "b[turret]-d[artillery]-a[heavy]",
	energy_per_sector = "10MJ",
	max_distance_of_nearby_sector_revealed = 3,
	max_distance_of_sector_revealed = 8,
	energy_per_nearby_scan = "1MW",
	energy_source =
	{
		type = "electric",
		usage_priority = "secondary-input"
	},
	energy_usage = "1MW",
	pictures = blank{},

	working_sound =
	{
		sound =
		{
			filename = "__Additional-Turret__/sound/Artillery_mk2_sound_base.ogg",
			volume = 0.7
		},
		match_volume_to_activity = true,
	},
},

--Range Overlay
{
	type = "ammo-turret",
	name = "at_Artillery_mk2_area",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk2-icon.png",
	flags = {"placeable-neutral", "placeable-player", "player-creation"},
	order = "b[turret]-d[artillery]-b[experimental]",
	max_health = 3500,
	resistances =
	{
		{ type = "physical", decrease = 20, percent = 60, },
	},
	corpse = "big-remnants",
	dying_explosion = "massive-explosion",
	
	collision_box = {{ -3.7, -2.7}, {3.7, 2.7}},
	selection_box = {{ -4, -3}, {4, 3}},
	
	folding_speed = 0.04,
	inventory_size = 1,
	automated_ammo_count = 10,
	
	folded_animation = at_Artillery_mk2_attack{},
	folding_animation = at_Artillery_mk2_attack{},

	attack_parameters =
	{
		type = "projectile",
		ammo_category = "artillery-mk2-shell",
		cooldown = 1500,
		range = 500,
		min_range = 100,
		projectile_creation_distance = 1.8,
		action ={},
	},
	call_for_help_radius = 40
},

--Artillery
{
	type = "container",
	name = "at_Artillery_mk2",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk2-icon.png",
	flags = {"placeable-neutral", "player-creation", "placeable-off-grid", "not-repairable"},
	minable = { mining_time = 10, result = "at_Artillery_mk2_area" },
	selectable_in_game = false,
	max_health = 3500,
	resistances =
	{
		{ type = "physical", decrease = 20, percent = 60, },
	},
	corpse = "big-remnants",
	dying_explosion = "big-explosion",
	collision_box = {{ 0, 0}, {0, 0}},
	selection_box = {{ 0, 0}, {0, 0}},
	order = "b[turret]-d[artillery]-b[experimental]",
	inventory_size = 1,
	
	picture = blank{},

	call_for_help_radius = 40
},

--Inventory
{
	type = "ammo-turret",
	name = "at_Artillery_mk2i",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk2-icon.png",
	flags = {"placeable-neutral", "placeable-player", "player-creation"},
	minable = { mining_time = 10, result = "at_Artillery_mk2_area" },
	order = "b[turret]-d[artillery]-b[experimental]",
	open_sound = { filename = "__Additional-Turret__/sound/Artillery_mk2_sound_open.ogg", volume=0.9 },
	max_health = 3500,
	resistances =
	{
		{ type = "physical", decrease = 20, percent = 60, },
	},
	corpse = "big-remnants",
	dying_explosion = "massive-explosion",
	collision_box = {{ -3.7, -2.7}, {3.7, 2.7}},
	selection_box = {{ -4, -3}, {4, 3}},
	folding_speed = 0.04,
	inventory_size = 1,
	automated_ammo_count = 10,
	
	folded_animation = at_Artillery_mk2_attack{},
	folding_animation = at_Artillery_mk2_attack{},
	
	vehicle_impact_sound =	{ filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },

	attack_parameters =
	{
		type = "projectile",
		ammo_category = "artillery-mk2-shell",
		cooldown = 1500,
		range = 0,
		projectile_creation_distance = 1.8,
		action ={},
	},
	call_for_help_radius = 40
},

--Radar
{
	type = "radar",
	name = "at_Artillery_mk2r",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk2-icon.png",
	flags = {"placeable-neutral", "player-creation", "placeable-off-grid", "not-repairable"},
	selectable_in_game = false,
	minable = {mining_time = 10, result = "at_Artillery_mk2_area"},
	max_health = 3500,
	resistances =
	{
		{ type = "physical", decrease = 20, percent = 60, },
	},
	corpse = "big-remnants",
	dying_explosion = "massive-explosion",
	collision_box = {{ 0, 0}, {0, 0}},
	selection_box = {{ 0, 0}, {0, 0}},
	order = "b[turret]-d[artillery]-b[experimental]",
	energy_per_sector = "100MJ",
	max_distance_of_nearby_sector_revealed = 6,
	max_distance_of_sector_revealed = 16,
	energy_per_nearby_scan = "5MW",
	energy_source =
	{
		type = "electric",
		usage_priority = "secondary-input"
	},
	energy_usage = "10MW",
	pictures = blank{},

	working_sound =
	{
		sound =
		{
			filename = "__Additional-Turret__/sound/Artillery_mk2_sound_base.ogg",
			volume = 1
		},
		match_volume_to_activity = true,
	},
},

--------target capsule entity
{
	type = "smoke-with-trigger",
	name = "target-cloud",
	flags = {"not-on-map"},
	show_when_smoke_off = true,
	animation =
	{
		filename = "__core__/graphics/shoot-cursor-red.png",
		priority = "low",
		width = 258,
		height = 183,
		frame_count = 1,
		animation_speed = 1,
		line_length = 1,
		scale = 1,
	},
	slow_down_factor = 0,
	affected_by_wind = false,
	cyclic = true,
	duration = 60 * 15, --15sec
	fade_away_duration = 2 * 60,
	spread_duration = 10,
	color = { r = 0.9, g = 0.2, b = 0.2 },
},
{
	type = "projectile",
	name = "target-capsule",
	flags = {"not-on-map"},
	acceleration = 0.005,
	action =
	{
		type = "direct",
		action_delivery =
		{
			type = "instant",
			target_effects =
			{
				type = "create-entity",
				trigger_created_entity = true,
				entity_name = "target-cloud"
			}
		}
	},
	light = {intensity = 0.5, size = 4},
	animation =
	{
		filename = "__base__/graphics/entity/poison-capsule/poison-capsule.png",
		frame_count = 1,
		width = 32,
		height = 32,
		priority = "high",
		tint = {r=1.0, g=0.2, b=0.2},
	},
	shadow =
	{
		filename = "__base__/graphics/entity/poison-capsule/poison-capsule-shadow.png",
		frame_count = 1,
		width = 32,
		height = 32,
		priority = "high"
	},
	smoke = capsule_smoke,
},
})




------------recipe
data:extend({
{
	type = "recipe",
	name = "at_Artillery_mk1_area",
	enabled = false,
	energy_required = 40,
	ingredients = 
	{
		{"steel-plate", 700},
		{"concrete", 300},
		{"pipe", 100},
		{"processing-unit", 100},
		{"engine-unit", 200},
		{"radar", 20},
	},
	result = "at_Artillery_mk1_area",
},
{
	type = "recipe",
	name = "Artillery_mk1_Ammo",
	enabled = false,
	energy_required = 20,
	ingredients =
	{
		-- {"artillery-shell", 5},
		{"piranha-core", 6},
		{"explosives", 5},
		{"steel-plate", 5},
		
	},
	result = "Artillery_mk1_Ammo",
},
{
	type = "recipe",
	name = "at_Artillery_mk2_area",
	enabled = false,
	energy_required = 60,
	ingredients = 
	{
		{"at_Artillery_mk1_area", 1},
		{"battery", 10},
		{"radar", 20},
		{"processing-unit", 30},
		{"alien-artifact", 50}
	},
	result = "at_Artillery_mk2_area",
},
{
	type = "recipe",
	name = "Artillery_mk2_Ammo",
	enabled = false,
	energy_required = 20,
	ingredients = 
	{
		{"Artillery_mk1_Ammo", 5},
		{"explosives", 7},
		{"steel-plate", 5},
		{"alien-artifact", 10}
	},
	result = "Artillery_mk2_Ammo",
},
{
	type = "recipe",
	name = "target-capsule",
	enabled = false,
	energy_required = 12,
	ingredients = 
	{
		{"poison-capsule", 1},
		{"slowdown-capsule", 1},
		{"explosives", 5},
		{"alien-artifact", 5}
	},
	result = "target-capsule",
},
})




---------------item
data:extend({
{
	type = "item",
	name = "at_Artillery_mk1_area",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk1-icon.png",
	flags = {"goes-to-quickbar"},
	subgroup = "defensive-structure",
	order = "b[turret]-d[artillery]-a[heavy]",
	place_result = "at_Artillery_mk1_area",
	stack_size = 1,
},
{
	type = "item",
	name = "at_Artillery_mk2_area",
	icon = "__Additional-Turret__/graphics/icon/turret-artillery-big-mk2-icon.png",
	flags = {"goes-to-quickbar"},
	subgroup = "defensive-structure",
	order = "b[turret]-d[artillery]-b[experimental]",
	place_result = "at_Artillery_mk2_area",
	stack_size = 1,
},


{
	type = "ammo",
	name = "Artillery_mk1_Ammo",
	icon = "__Additional-Turret__/graphics/icon/ammo-artillery-1-icon.png",
	flags = {"goes-to-main-inventory"},
	ammo_type =
	{
		category = "artillery-mk1-shell",
		target_type = "direction",
		action =
		{
			type = "direct",
			action_delivery =
			{
				type = "projectile",
				projectile = "dummy_entity",
				starting_speed = 0.5,
				source_effects =
				{
					type = "create-explosion",
					entity_name = "explosion"
				}
			}
		},
	},
	subgroup = "ammo",
	order = "e[artillery-shell]-a[heavy]",
	stack_size = 10
},
{
	type = "ammo",
	name = "Artillery_mk2_Ammo",
	icon = "__Additional-Turret__/graphics/icon/ammo-artillery-2-icon.png",
	flags = {"goes-to-main-inventory"},
	ammo_type =
	{
		category = "artillery-mk2-shell",
		target_type = "direction",
		action =
		{
			type = "direct",
			action_delivery =
			{
				type = "projectile",
				projectile = "dummy_entity",
				starting_speed = 0.5,
				source_effects =
				{
					type = "create-explosion",
					entity_name = "explosion"
				}
			}
		},
	},
	subgroup = "ammo",
	order = "e[artillery-shell]-b[experimental]",
	stack_size = 10
},


{
	type = "capsule",
	name = "target-capsule",
	icon = "__Additional-Turret__/graphics/icon/ammo-target-capsule-icon.png",
	flags = {"goes-to-quickbar"},
	capsule_action =
	{
		type = "throw",
		attack_parameters =
		{
			type = "projectile",
			ammo_category = "capsule",
			cooldown = 60*10,
			projectile_creation_distance = 0.6,
			range = 40,
			ammo_type =
			{
				category = "capsule",
				target_type = "position",
				action =
				{
					type = "direct",
					action_delivery =
					{
						type = "projectile",
						projectile = "target-capsule",
						starting_speed = 0.3
					}
				}
			}
		}
	},
	subgroup = "capsule",
	order = "g[target-capsule]",
	stack_size = 20
},
})